module.exports = function($uibModal, $storage, $document, $log, authService) {
    var login = function () {
        $storage.session.clear();

        var modalInstance = $uibModal.open({
            ariaLabelledBy: 'modal-title',
            ariaDescribedBy: 'modal-body',
            templateUrl: loginTmpl,
            controller: 'LoginModalController',
            controllerAs: '$ctrl'
        });

        modalInstance.result.then(function (data) {
            $log.log(data);

            $storage.session.set('refresh_token', data.refresh_token);
            $storage.session.set('access_token', data.access_token);

            authService.loginConfirmed();
        }, function () {
            $log.info('Modal dismissed at: ' + new Date());

            // FIXME Alexis Lahouze 2017-06-11 Redirect to error page.
            authService.loginCancelled(null, 'Login cancelled by user action.');
        });
    };

    var cancelLogin = function () {
        // FIXME Alexis Lahouze 2017-06-11 Redirect to error page.
    };

    return {
        'login': login,
        'cancelLogin': cancelLogin
    };
};
